import { PropertyScalar } from "../../properties/property-scalar";
import { AbstractProperty } from "../../properties/abstract-property";
import { PropertyDependencyOptions } from "../../dependency-graph/property-dependency";
import { AttributeId } from "../../attributes/attribute-id";
import { ScalarValidator, Validator } from "../../validators/validator";
export declare enum TextInterpreter {
    Plain = 0,
    Markdown = 1,
    Html = 2
}
export declare class PropertyScalarRuleBinding<T> {
    private readonly notEmptyIfRequiredValidator;
    private readonly addDependencies;
    private readonly property;
    constructor(property: PropertyScalar<T>, notEmptyIfRequiredValidator: ScalarValidator<unknown>, addDependencies: (from: AbstractProperty<unknown>[], to: AbstractProperty<T>, options: PropertyDependencyOptions) => void);
    addScalarValidator(validator: ScalarValidator<T>): PropertyScalarRuleBinding<T>;
    addValidator(validator: Validator): PropertyScalarRuleBinding<T>;
    defineInitialValue(value: T): PropertyScalarRuleBinding<T>;
    define<A>(attribudeId: AttributeId<A>, value: A | ((self: PropertyScalar<T>) => A)): PropertyScalarRuleBinding<T>;
    private defineAttributeFunction;
    defineVisibility(isVisible: boolean | ((self: PropertyScalar<T>) => boolean)): PropertyScalarRuleBinding<T>;
    defineVisibility1<D1 extends AbstractProperty<unknown>>(dep1: D1, isVisible: (self: PropertyScalar<T>, dep1: D1) => boolean): PropertyScalarRuleBinding<T>;
    defineVisibility2<D1 extends AbstractProperty<unknown>, D2 extends AbstractProperty<unknown>>(dep1: D1, dep2: D2, isVisible: (self: PropertyScalar<T>, dep1: D1, dep2: D2) => boolean): PropertyScalarRuleBinding<T>;
    private defineVisibilityFunction;
    defineRequiredIfVisible(required: boolean | ((self: PropertyScalar<T>) => boolean)): PropertyScalarRuleBinding<T>;
    private defineRequiredIfVisibleFunction;
    defineLabelAndPlaceholder(text: string): PropertyScalarRuleBinding<T>;
    defineLabel(text: string, textInterpreter?: TextInterpreter): PropertyScalarRuleBinding<T>;
    definePlaceholder(placeholder: string): PropertyScalarRuleBinding<T>;
    defineInfoText(text: string, textInterpreter?: TextInterpreter): PropertyScalarRuleBinding<T>;
    private interpreteText;
    onUpdated(updated: (self: PropertyScalar<T>) => void): this;
    setToInitialValueOnOtherPropertyChanged(...otherProperties: AbstractProperty<unknown>[]): this;
}
