import { PropertyId } from "./property-id";
import { ValueChangeListener } from "./value-change-listener";
import { Trigger } from "./trigger";
import { DataLink } from "./data-link/data-link";
import { BackpressureConfig } from "./backpressure/backpressure-config";
import { ValidationMessage } from "../validators/validation-message";
export declare type DataTypeOfProperty<T extends AbstractProperty<unknown>> = T extends AbstractProperty<string> ? string : (T extends AbstractProperty<number> ? number : (T extends AbstractProperty<boolean> ? boolean : (T extends AbstractProperty<Date> ? Date : (T extends AbstractProperty<string[]> ? string[] : (T extends AbstractProperty<number[]> ? number[] : (T extends AbstractProperty<boolean[]> ? boolean[] : (T extends AbstractProperty<Date[]> ? Date[] : unknown)))))));
export interface AbstractProperty<D> extends DataLink<D> {
    readonly id: PropertyId;
    needsAnUpdate(notifyOthers?: boolean): void;
    registerValueChangedListener(changed: ValueChangeListener): void;
    deregisterValueChangedListener(changed: ValueChangeListener): void;
    setUpdateStrategy(strategy: 'Automatic' | 'Manually'): void;
    addUpdateTrigger(trigger: Trigger): void;
    addUpdateTrigger(trigger: Trigger, setUpdateStrategyManually: boolean): void;
    removeUpdateTrigger(trigger: Trigger): void;
    validate(): Promise<void>;
    isValid(): boolean;
    getValidationMessages(): ValidationMessage[];
    isAsynchronous(): boolean;
    backpressureConfig?: BackpressureConfig;
    isProcessing(): boolean;
    isReadOnly(): boolean;
}
