import { Validator, ValidationResult } from "./validator";
import { AbstractProperty } from "../properties/abstract-property";
import { PropertyScalar } from "../properties/property-scalar";
import { ValidationMessage } from "./validation-message";
import { PropertyId } from "../properties/property-id";
export declare abstract class AsynchronousValidator<T, R> implements Validator {
    private readonly validatedProperties;
    private readonly furtherProperties;
    private lastValidationResult;
    constructor(validatedProperties: PropertyScalar<T>[], furtherProperties: PropertyScalar<T>[]);
    getValidatedProperties(): AbstractProperty<T>[];
    getAdditionalProperties(): AbstractProperty<T>[];
    abstract needsValidation(validatedProperties: PropertyScalar<T>[], furtherProperties: PropertyScalar<T>[]): boolean;
    abstract process(validatedProperties: PropertyScalar<T>[], furtherProperties: PropertyScalar<T>[]): Promise<R>;
    abstract getMessagesFromResult(result: R): Map<PropertyId, ValidationMessage[]> | ValidationMessage[];
    abstract getMessageOnError(error: Error): ValidationMessage;
    validate(): Promise<ValidationResult>;
    getLastValidationResult(): ValidationResult;
    isAsynchronous(): boolean;
}
