"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotEmptyIfRequiredValidator = exports.ConditionalValidator = exports.V = void 0;
exports.V = {
    conditionalFcns: (validators) => new ConditionalValidator(validators),
    notEmpty: (msg) => new NotEmptyIfRequiredValidator(() => msg),
    notEmptyMsgProvider: (valiationMsgProvider) => new NotEmptyIfRequiredValidator(valiationMsgProvider),
};
class ConditionalValidator {
    constructor(validators) {
        this.validators = validators;
    }
    validate(property) {
        var _a, _b;
        return (_b = (_a = this.validators.find(v => v.condition)) === null || _a === void 0 ? void 0 : _a.valideFcn(property)) !== null && _b !== void 0 ? _b : null;
    }
}
exports.ConditionalValidator = ConditionalValidator;
class NotEmptyIfRequiredValidator {
    constructor(valiationMessageProvider) {
        this.valiationMessageProvider = valiationMessageProvider;
    }
    validate(property) {
        if (!property.isEmpty() || !property.isRequired()) {
            return null;
        }
        else {
            return this.valiationMessageProvider();
        }
    }
}
exports.NotEmptyIfRequiredValidator = NotEmptyIfRequiredValidator;
