import { AbstractProperty } from "../properties/abstract-property";
import { PropertyId } from "../properties/property-id";
import { ValidationMessage } from "./validation-message";
import { PropertyScalar } from "../properties/property-scalar";
export interface ValidationResult {
    getMessages(propertyId: PropertyId): ValidationMessage[] | null;
}
export declare const ValidationPassed: ValidationResult;
export interface ScalarValidator<T> {
    validate(property: PropertyScalar<T>): ValidationMessage | null;
}
export interface Validator {
    getValidatedProperties(): AbstractProperty<unknown>[];
    getAdditionalProperties(): AbstractProperty<unknown>[];
    validate(): Promise<ValidationResult>;
    getLastValidationResult(): ValidationResult;
    isAsynchronous(): boolean;
}
