import { RuleEngineDescription } from "./rule-engine-description";
import { AbstractProperty } from "../properties/abstract-property";
import { RuleEngineUpdateHandler } from "./rule-engine-update-handler";
import { Snapshot } from "./snapshot/snapshot";
import { RuleBuilderOptions } from "./builder/rule-builder-options";
import { RuleBuilder } from "./builder/rule-builder";
export declare class RuleEngine implements RuleEngineUpdateHandler<unknown> {
    private readonly propertyMap;
    private readonly dependencyGraph;
    private readonly dataLinks;
    private readonly snapshots;
    private propertiesThatRequireAnEagerUpdate;
    private get properties();
    builder(options: RuleBuilderOptions): RuleBuilder;
    takeSnapShot(key?: string): Snapshot;
    restoreSnapShot(key?: string): void;
    linkPropertyData<D>(propertyA: AbstractProperty<D>, propertyB: AbstractProperty<D>): void;
    unlinkPropertyData<D>(propertyA: AbstractProperty<D>, propertyB: AbstractProperty<D>): void;
    private createDataLinkKey;
    transferData<D>(fromProperty: AbstractProperty<D>, toProperty: AbstractProperty<D>): void;
    needsAnUpdate(mightHaveChanged: AbstractProperty<unknown>): void;
    updateValue(property: AbstractProperty<unknown>): Promise<void>;
    private hasBeenUpdated;
    static serialize(engine: RuleEngine): string;
    static deserialize(serialized: string): RuleEngine;
    static createFromRuleEngineDescription(description: RuleEngineDescription): RuleEngine;
}
