import { ValueProvider } from "./value-provider";
import { AbstractProperty } from "../../properties/abstract-property";
export declare class DerivedAsyncValueProvider<T> implements ValueProvider<T> {
    private readonly dependencies;
    private readonly get;
    private readonly set?;
    private processing;
    constructor(dependencies: AbstractProperty<unknown>[], get: (dependencies: AbstractProperty<unknown>[]) => Promise<T | null>, set?: ((dependencies: AbstractProperty<unknown>[], value: T | null) => Promise<void>) | undefined);
    getValue(): Promise<T | null>;
    setValue(value: T | null): void;
    isAsynchronous(): boolean;
    isProcessing(): boolean;
    shouldBeCached(): boolean;
    isReadOnly(): boolean;
}
