import { Validator, ValidationResult } from "./validator";
import { AbstractProperty } from "../properties/abstract-property";
import { PropertyScalar } from "../properties/property-scalar";
import { ValidationMessage } from "./validation-message";
export declare abstract class AsynchronousSingleValidator<T, R> implements Validator {
    private readonly lastValue?;
    private lastValidationResult;
    private readonly propertyList;
    constructor(property: PropertyScalar<T>);
    getValidatedProperties(): AbstractProperty<T>[];
    getAdditionalProperties(): AbstractProperty<T>[];
    abstract process(value: T | null): Promise<R>;
    abstract getMessagesFromResult(result: R): ValidationMessage[];
    abstract getMessageOnError(error: Error): ValidationMessage | null;
    validate(): Promise<ValidationResult>;
    getLastValidationResult(): ValidationResult;
    isAsynchronous(): boolean;
}
