import { PropertyScalar } from "../properties/property-scalar";
import { ValidationMessage } from "./validation-message";
import { ScalarValidator } from "./validator";
export declare const V: {
    conditionalFcns: <T>(validators: {
        condition: boolean;
        valideFcn: (property: PropertyScalar<T>) => ValidationMessage | null;
    }[]) => ConditionalValidator<T>;
    notEmpty: (msg: ValidationMessage) => NotEmptyIfRequiredValidator;
    notEmptyMsgProvider: (valiationMsgProvider: () => ValidationMessage) => NotEmptyIfRequiredValidator;
};
export declare class ConditionalValidator<T> implements ScalarValidator<T> {
    protected validators: {
        condition: boolean;
        valideFcn: (property: PropertyScalar<T>) => ValidationMessage | null;
    }[];
    constructor(validators: {
        condition: boolean;
        valideFcn: (property: PropertyScalar<T>) => ValidationMessage | null;
    }[]);
    validate(property: PropertyScalar<T>): ValidationMessage | null;
}
export declare class NotEmptyIfRequiredValidator implements ScalarValidator<unknown> {
    protected valiationMessageProvider: () => ValidationMessage;
    constructor(valiationMessageProvider: () => ValidationMessage);
    validate(property: PropertyScalar<unknown>): ValidationMessage | null;
}
