import { RuleEngine } from "./rule-engine";
import { RuleEngineDescription } from "./rule-engine-description";

/**
 * Can be generated by RuleBuilder
 */
const description: RuleEngineDescription = {
    todo: () => {
        //
    }
};

export class RuleEngineFactory {

    private ruleEngine?: RuleEngine;

    getInstance(): RuleEngine {
        if (!this.ruleEngine) {
            if (!description) {
                throw new Error('Not generated, yet');
            }
            this.ruleEngine = RuleEngine.createFromRuleEngineDescription(description);
        }
        return this.ruleEngine;
    }
}
